/************************************************************************
*	Modular CODEC Manager for ADSP-2191
*		Written by Horie, Seiichi
*		(c) 2002, ADKK.
*
*************************************************************************/
/************************************************************************
*	History
*
*	Jul.11.2003 : Horie, Seiichi
*	Now, this file is included by mcm.h. Do not include this file directly.
*
*	Jul.24.2002 : Horie, Seiichi
*	First release.
*	
*
*************************************************************************/
// #include "mcm.h"
#ifndef INCL_MCM2191
#define INCL_MCM2191

namespace mcm{

/**************************************************************************
*	
* SPORT handling class. 
*	
* You can use this class also for ADSP-2195/96 because they employes
* exactly same IO mapping with ADSP-2191.
*
**************************************************************************/		

	class sport2191 : public sport{
	private:
		sample * txa, * txb, * rxa, * rxb;
	public:
		sport2191( int aPort );
		virtual sample * curRxBuf( );		// return currently available buffer
		virtual sample * curTxBuf( );		// return 0 or 1
		virtual void initAndStart( int bufSize, sample * bufTxA, sample * bufRxA );		// init sport and codec and then start transmission.
		virtual void stopAndWait();		// stop to transmitt and then wait done
		virtual void clearInterrupt();		// clear the interrupt at interrrupt handler. if needed.
	};
	


 
/*************************************************************************
*
* Critical section for interrupt driven application.
* disable. You can use this also for ADSP-2195/2196
*
*************************************************************************/


	class criticalsection2191Basic: public criticalsection{
	private:
		int savedICNTL;
	public:
		virtual void enter();
		virtual void leave();
	};
	
/**************************************************************************
*	
* Resetting AC97 codec by hardware on EZ-KIT Lite
*	
**************************************************************************/	

	class resetEzKit2191 : public reset{
	public:
		resetEzKit2191( int megaHertz ) : reset( megaHertz ) { }
		virtual void assert( int port );
		virtual void deassert( int port );
	};

/**************************************************************************
*	
* A simplified class for EZ-KIT 2191 interrupt driven application
*	
**************************************************************************/	

	class fwEzKit2191 : public framework {
	public:
		fwEzKit2191( int aBufSize = 48 );	
	};
	

	
};
#endif //INCL_MCM2191

