#include "modem.h"
#define LPFTAPS 255
#define BPFTAPS 255

static short lpfCoeff[LPFTAPS]={
#include "lpf.txt"
};

short bpfCoeff[BPFTAPS]={
#include "bpf.txt"
};

//**************************************************************************
//
//  CModulator::CModulator̒`
//
//
//**************************************************************************
CModulator::CModulator():mcm::fwEzKit2191(256)
{
	osc1 = new stk::CSinCosDDS(2048, 0);	// 1.5KHz
	osc2 = new stk::CSinCosDDS(16384, 0);	// 12KHz
	osc3 = new stk::CSinCosDDS(14336, 0);	// 10.5KHz
	
	lpf_i = new stk::CFirFilter( LPFTAPS, lpfCoeff );
	lpf_q = new stk::CFirFilter( LPFTAPS, lpfCoeff );
	bpf =   new stk::CFirFilter( BPFTAPS, bpfCoeff );
	
	temp_i = new short[bufSize];
	temp_q = new short[bufSize];

	
	lo_i = new short[bufSize];
	lo_q = new short[bufSize];
	in = new short[bufSize];
	
}

//**************************************************************************
//
//  CModulator::~CModulator̒`
//
//
//**************************************************************************
CModulator::~CModulator()
{
	delete osc1;
	delete osc2;
	delete osc3;
	delete lpf_i;
	delete lpf_q;
	delete bpf;
	
	delete temp_i;
	delete temp_q;
	delete lo_i;
	delete lo_q;
	delete in;
}
//**************************************************************************
//
//  CModem::handleBuffer̒`
//
//  handleBuffer\bhDMA]I邽тɎMobt@ƑM
//  obt@p[^ɌĂ΂BMobt@ɂ͒ODMAŎM
//  f[^ĂBhandleBuffer߂ƂɑMobt@Ƀf[^
//  ĂƁADMA]őMB
//
//**************************************************************************


void CModulator::handleBuffer( struct mcm::sample * bufTx, 
							struct mcm::sample * bufRx )
{
	short step;
	
	step = sizeof(mcm::sample);
			// make stereo to monoral
	stk::copy( in, &bufRx[0].r, bufSize, 1, step );
	osc1->run( lo_i, lo_q, bufSize );			// g
	stk::mul( temp_i, in, lo_i, bufSize );	// MIX
	stk::mul( temp_q, in, lo_q, bufSize );

	lpf_i->run( temp_i, temp_i, bufSize );		// Jbg
	lpf_q->run( temp_q, temp_q, bufSize );

	osc2->run( lo_i, lo_q, bufSize );			// g
	stk::mul( temp_i, temp_i, lo_i, bufSize );	// MIX
	stk::mul( temp_q, temp_q, lo_q, bufSize );

	stk::add( temp_i, temp_i, temp_q, bufSize);

			// BFO
	osc3->run( lo_i, lo_q, bufSize );
	stk::add( temp_q, temp_i, lo_i, bufSize );	// BFO
	stk::max( temp_i, temp_q, (short)0, bufSize	); // _CI[hg

	bpf->run( temp_q, temp_i, bufSize );		// ̈悾o
				
	stk::copy( &bufTx[0].r, temp_q, bufSize, step, 1 );
	stk::copy( &bufTx[0].l, temp_q, bufSize, step, 1 );
}

